<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: exampleIMUTracking.m</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_user.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For MATLAB, Python, Java, and C++ users</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('exampleIMUTracking_8m-example.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">exampleIMUTracking.m</div>  </div>
</div><!--header-->
<div class="contents">
<p>This is an example that uses a squat-to-stand motion to create synthetic accelerometer data, and then creates a tracking simulation to track the synthetic accelerometer signals. This example is used in hands-on workshops, and accordingly has blanks that users must fill in. See <a class="el" href="exampleSquatToStand_answers_8m-example.html">exampleSquatToStand_answers.m</a> for a completed version.</p>
<div class="fragment"><div class="line"><span class="keyword">function</span> exampleIMUTracking</div>
<div class="line">clc; clear; close all;</div>
<div class="line"> </div>
<div class="line">%% Part 0: Load the Moco libraries.</div>
<div class="line">addpath(<span class="stringliteral">&#39;../&#39;</span>); % Add the directory above to access mocoPlotTrajectory.m</div>
<div class="line"><span class="keyword">import</span> org.opensim.modeling.*;</div>
<div class="line"> </div>
<div class="line">%% Part 1: Load model and add IMU frames.</div>
<div class="line">% Part 1a: Load a torque-driven, 3 degree-of-freedom model with a single leg </div>
<div class="line">% and foot welded to the floor. See the function definition at the bottom of</div>
<div class="line">% this file to see how the model is loaded and constructed.</div>
<div class="line">model = getTorqueDrivenSquatToStandModel();</div>
<div class="line"> </div>
<div class="line">% Part 1b: Add frames to the model that will represent our IMU locations. </div>
<div class="line">% The <span class="keyword">function</span> addIMUFrame() adds a PhysicalOffsetFrame to a body at a </div>
<div class="line">% specified location and orientation. Each frame is added at the path:</div>
<div class="line">%</div>
<div class="line">% /bodyset/&lt;body_name&gt;/&lt;body_name&gt;_imu_offset</div>
<div class="line">%</div>
<div class="line">addIMUFrame(model, &#39;torso&#39;,   Vec3(0.08, 0.3, 0), Vec3(0, 0.5*pi, 0.5*pi));</div>
<div class="line">addIMUFrame(model, &#39;femur_r&#39;, Vec3(0, -0.2, 0.05), Vec3(0, 0, 0.5*pi));</div>
<div class="line">addIMUFrame(model, &#39;tibia_r&#39;, Vec3(0, -0.2, 0.05), Vec3(0, 0, 0.5*pi));</div>
<div class="line"> </div>
<div class="line">% Part 1c: Add IMU components to the model using the PhysicalOffsetFrames</div>
<div class="line">% we just added to the model. We&#39;ll use the helper function addModelIMUs()</div>
<div class="line">% included with OpenSenseUtilities.</div>
<div class="line">imuFramePaths = StdVectorString();</div>
<div class="line">imuFramePaths.add( );</div>
<div class="line">imuFramePaths.add( );</div>
<div class="line">imuFramePaths.add( );</div>
<div class="line">OpenSenseUtilities().addModelIMUs(model, imuFramePaths);</div>
<div class="line">model.initSystem();</div>
<div class="line"> </div>
<div class="line">%% Part 2: Solve an effort minimization predictive problem</div>
<div class="line">% Generate a simulation of a squat-to-stand motion that minimizes control</div>
<div class="line">% effort. We&#39;ll use the results from this simulation to compute a set of </div>
<div class="line">% &quot;synthetic&quot; accelerometer signals later.</div>
<div class="line"> </div>
<div class="line">% Part 2a: Create a new MocoStudy.</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">% Part 2b: Initialize the problem and set the model.</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">% Part 2c: Set bounds on the problem.</div>
<div class="line">%</div>
<div class="line">% problem.setTimeBounds(initial_bounds, final_bounds)</div>
<div class="line">% problem.setStateInfo(path, trajectory_bounds, inital_bounds, final_bounds)</div>
<div class="line">%</div>
<div class="line">% All *_bounds arguments can be set to a range, [lower upper], or to a</div>
<div class="line">% single value (equal lower and upper bounds). Empty brackets, [], indicate</div>
<div class="line">% using default bounds (if they exist). You may set multiple state infos at</div>
<div class="line">% once using setStateInfoPattern():</div>
<div class="line">%</div>
<div class="line">% problem.setStateInfoPattern(pattern, trajectory_bounds, inital_bounds, ...</div>
<div class="line">%       final_bounds)</div>
<div class="line">%</div>
<div class="line">% This function supports regular expressions in the &#39;pattern&#39; argument;</div>
<div class="line">% use &#39;.*&#39; to match any substring of the state/control path</div>
<div class="line">% For example, the following will set all coordinate value state infos:</div>
<div class="line">%</div>
<div class="line">% problem.setStateInfoPattern(&#39;/path/to/states/.*/value&#39;, ...)</div>
<div class="line"> </div>
<div class="line">% Time bounds</div>
<div class="line">problem.setTimeBounds( );</div>
<div class="line"> </div>
<div class="line">% Position bounds: the model should start in a squat and finish </div>
<div class="line">% standing up.</div>
<div class="line">problem.setStateInfo(&#39;/jointset/hip_r/hip_flexion_r/value&#39;, );</div>
<div class="line">problem.setStateInfo(&#39;/jointset/knee_r/knee_angle_r/value&#39;, );</div>
<div class="line">problem.setStateInfo(&#39;/jointset/ankle_r/ankle_angle_r/value&#39;, );</div>
<div class="line"> </div>
<div class="line">% Velocity bounds: all model coordinates should start and end at rest.</div>
<div class="line">problem.setStateInfoPattern(&#39;/jointset/.*/speed&#39;, );</div>
<div class="line"> </div>
<div class="line">% Part 2d: Add a MocoControlGoal to the problem.</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">% Part 2e: Configure the solver.</div>
<div class="line">solver = study.initCasADiSolver();</div>
<div class="line">solver.set_num_mesh_intervals( );</div>
<div class="line">solver.set_optim_convergence_tolerance( );</div>
<div class="line">solver.set_optim_constraint_tolerance( );</div>
<div class="line"> </div>
<div class="line">if ~exist(&#39;predictSolution.sto&#39;, &#39;file&#39;)</div>
<div class="line">    % Part 2f: Solve! Write the solution to file, and visualize.</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">end</div>
<div class="line"> </div>
<div class="line">%% Part 3: Compute synthetic accelerometer signals</div>
<div class="line">% In this step, we&#39;ll create a set of synthetic accelerometer signals that </div>
<div class="line">% replicate the output of an IMU sensor. To do this, we&#39;ll use the </div>
<div class="line">% &#39;accelerometer_signal&#39; Output included with the IMU components we</div>
<div class="line">% previously added to the model. </div>
<div class="line"> </div>
<div class="line">% Part 3a: Load the prediction solution.</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">% Part 3b: Compute the accelerometer signals using the analyzeVec3() free</div>
<div class="line">% function included with SimulationUtilities. These free functions can be</div>
<div class="line">% accessed in scripting by using the &#39;opensimSimulation&#39; prefix. </div>
<div class="line">outputPaths = StdVectorString();</div>
<div class="line">outputPaths.add( );</div>
<div class="line">accelerometerSignals = opensimSimulation.analyzeVec3(model, ...</div>
<div class="line">    predictSolution.exportToStatesTable(), ...</div>
<div class="line">    predictSolution.exportToControlsTable(), ...</div>
<div class="line">    outputPaths);</div>
<div class="line"> </div>
<div class="line">% Part 3c: Update the column labels of the accelerometer signals to match</div>
<div class="line">% the offset frame paths. This is necessary for the tracking goal we&#39;ll add</div>
<div class="line">% to the problem in Part 4. </div>
<div class="line">accelerometerSignals.setColumnLabels(imuFramePaths);</div>
<div class="line"> </div>
<div class="line">% Part 3d: Plot the synthetic acceleration signals.</div>
<div class="line">plotAccelerationSignals(accelerometerSignals);</div>
<div class="line"> </div>
<div class="line">%% Part 4: Synthetic acceleration tracking problem </div>
<div class="line">% Part 4a: Add a MocoAccelerationTrackingGoal to the MocoProblem. Set the</div>
<div class="line">% frame paths to the IMU offset frame paths and set the accelerations </div>
<div class="line">% reference to the synthetic accelerometer signals we calculated above.</div>
<div class="line">% We need to subtract the gravitational acceleration vector and re-express</div>
<div class="line">% the accelerations in the tracking frames so that the model-computed</div>
<div class="line">% values in the tracking cost match the accelerometer signals.</div>
<div class="line">tracking = </div>
<div class="line">tracking.setFramePaths( );</div>
<div class="line">tracking.setAccelerationReference( );</div>
<div class="line">tracking.setGravityOffset( );</div>
<div class="line">tracking.setExpressAccelerationsInTrackingFrames( );</div>
<div class="line">problem.addGoal( );</div>
<div class="line"> </div>
<div class="line">% Part 4b: Reduce the control cost weight so that the tracking term will</div>
<div class="line">% dominate.</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">if ~exist(&#39;trackingSolution.sto&#39;, &#39;file&#39;)</div>
<div class="line">    % Part 4c: Solve! Write the solution to file, and visualize.</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">end</div>
<div class="line"> </div>
<div class="line">%% Part 5: Compare tracking solution to original prediction</div>
<div class="line">% Part 5a: Plot the tracking solution against the prediction. This is a</div>
<div class="line">% convenience function provided for you. See mocoPlotTrajectory.m</div>
<div class="line">mocoPlotTrajectory(&#39;predictSolution.sto&#39;, &#39;trackingSolution.sto&#39;, ...</div>
<div class="line">        &#39;predict&#39;, &#39;track&#39;);</div>
<div class="line"> </div>
<div class="line">% Part 5b: Compare accelerations from tracking solution to the reference</div>
<div class="line">% accelerations.</div>
<div class="line">trackingSolution = MocoTrajectory(&#39;trackingSolution.sto&#39;);</div>
<div class="line">accelerometerSignalsTracking = opensimSimulation.analyzeVec3(model, ...</div>
<div class="line">    trackingSolution.exportToStatesTable(), ...</div>
<div class="line">    trackingSolution.exportToControlsTable(), ...</div>
<div class="line">    outputPaths);</div>
<div class="line">accelerometerSignalsTracking.setColumnLabels(imuFramePaths);</div>
<div class="line">plotAccelerationSignals(accelerometerSignals, accelerometerSignalsTracking)</div>
<div class="line"> </div>
<div class="line">end</div>
<div class="line"> </div>
<div class="line">%% Model Creation and Plotting Convenience Functions </div>
<div class="line"> </div>
<div class="line">function addCoordinateActuator(model, coordName, optForce)</div>
<div class="line"> </div>
<div class="line">import org.opensim.modeling.*;</div>
<div class="line"> </div>
<div class="line">coordSet = model.updCoordinateSet();</div>
<div class="line"> </div>
<div class="line">actu = CoordinateActuator();</div>
<div class="line">actu.setName([&#39;tau_&#39; coordName]);</div>
<div class="line">actu.setCoordinate(coordSet.get(coordName));</div>
<div class="line">actu.setOptimalForce(optForce);</div>
<div class="line">actu.setMinControl(-1);</div>
<div class="line">actu.setMaxControl(1);</div>
<div class="line"> </div>
<div class="line">% Add to ForceSet</div>
<div class="line">model.addForce(actu);</div>
<div class="line"> </div>
<div class="line">end</div>
<div class="line"> </div>
<div class="line">function [model] = getTorqueDrivenSquatToStandModel()</div>
<div class="line"> </div>
<div class="line">import org.opensim.modeling.*;</div>
<div class="line"> </div>
<div class="line">% Load the base model.</div>
<div class="line">model = Model(&#39;../squatToStand_3dof9musc.osim&#39;);</div>
<div class="line"> </div>
<div class="line">% Remove the muscles in the model.</div>
<div class="line">model.updForceSet().clearAndDestroy();</div>
<div class="line">model.initSystem();</div>
<div class="line"> </div>
<div class="line">% Add CoordinateActuators to the model degrees-of-freedom.</div>
<div class="line">addCoordinateActuator(model, &#39;hip_flexion_r&#39;, 150);</div>
<div class="line">addCoordinateActuator(model, &#39;knee_angle_r&#39;, 300);</div>
<div class="line">addCoordinateActuator(model, &#39;ankle_angle_r&#39;, 150);</div>
<div class="line"> </div>
<div class="line">end</div>
<div class="line"> </div>
<div class="line">function addIMUFrame(model, bodyName, translation, orientation)</div>
<div class="line"> </div>
<div class="line">import org.opensim.modeling.*;</div>
<div class="line"> </div>
<div class="line">body = model.updBodySet().get(bodyName);</div>
<div class="line">name = [<span class="keywordtype">char</span>(body.getName()) &#39;_imu_offset&#39;];</div>
<div class="line">bodyOffset = PhysicalOffsetFrame(name, body, Transform());</div>
<div class="line">bodyOffset.set_translation(translation);</div>
<div class="line">bodyOffset.set_orientation(orientation);</div>
<div class="line">body.addComponent(bodyOffset);</div>
<div class="line">model.finalizeConnections();</div>
<div class="line"> </div>
<div class="line">end</div>
<div class="line"> </div>
<div class="line">function plotAccelerationSignals(varargin)</div>
<div class="line"> </div>
<div class="line">import org.opensim.modeling.*;</div>
<div class="line"> </div>
<div class="line">accelerationsReference = varargin{1};</div>
<div class="line"><span class="keywordflow">if</span> nargin == 2</div>
<div class="line">    accelerationsTracking = varargin{2};</div>
<div class="line">end</div>
<div class="line"> </div>
<div class="line">% Create a time vector that can be used <span class="keywordflow">for</span> plotting</div>
<div class="line">timeVec = accelerationsReference.getIndependentColumn();</div>
<div class="line">time = zeros(timeVec.size(),1);</div>
<div class="line"><span class="keywordflow">for</span> i = 1:timeVec.size()</div>
<div class="line">   time(i) = timeVec.get(i-1);</div>
<div class="line">end</div>
<div class="line"> </div>
<div class="line">figure;</div>
<div class="line">% Plot the torso accelerations</div>
<div class="line">subplot(1,3,1)</div>
<div class="line">torso = accelerationsReference.getDependentColumn(...</div>
<div class="line">    &#39;/bodyset/torso/torso_imu_offset&#39;).getAsMat();</div>
<div class="line">plot(time, torso(:,1), &#39;r-&#39;, &#39;linewidth&#39;, 3)</div>
<div class="line">if nargin == 2</div>
<div class="line">hold on</div>
<div class="line">torsoTrack = accelerationsTracking.getDependentColumn(...</div>
<div class="line">    &#39;/bodyset/torso/torso_imu_offset&#39;).getAsMat();</div>
<div class="line">plot(time, torsoTrack(:,1), &#39;b--&#39;, &#39;linewidth&#39;, 3)</div>
<div class="line">end</div>
<div class="line">if nargin == 2</div>
<div class="line">    legend(&#39;predict&#39;, &#39;track&#39;, &#39;location&#39;, &#39;best&#39;);</div>
<div class="line">end</div>
<div class="line">title(&#39;torso&#39;)</div>
<div class="line">xlabel(&#39;time (s)&#39;)</div>
<div class="line">ylabel(&#39;acceleration (m/s^2)&#39;)</div>
<div class="line"> </div>
<div class="line">% Plot the femur accelerations</div>
<div class="line">subplot(1,3,2)</div>
<div class="line">femur = accelerationsReference.getDependentColumn(...</div>
<div class="line">    &#39;/bodyset/femur_r/femur_r_imu_offset&#39;).getAsMat();</div>
<div class="line">plot(time, femur(:,1), &#39;r-&#39;, &#39;linewidth&#39;, 3)</div>
<div class="line">if nargin == 2</div>
<div class="line">hold on</div>
<div class="line">femurTrack = accelerationsTracking.getDependentColumn(...</div>
<div class="line">    &#39;/bodyset/femur_r/femur_r_imu_offset&#39;).getAsMat();</div>
<div class="line">plot(time, femurTrack(:,1), &#39;b--&#39;, &#39;linewidth&#39;, 3)</div>
<div class="line">end</div>
<div class="line">title(&#39;femur&#39;)</div>
<div class="line">xlabel(&#39;time (s)&#39;)</div>
<div class="line">ylabel(&#39;acceleration (m/s^2)&#39;)</div>
<div class="line"> </div>
<div class="line">% Plot the tibia accelerations</div>
<div class="line">subplot(1,3,3)</div>
<div class="line">tibia = accelerationsReference.getDependentColumn(...</div>
<div class="line">    &#39;/bodyset/tibia_r/tibia_r_imu_offset&#39;).getAsMat();</div>
<div class="line">plot(time, tibia(:,1), &#39;r-&#39;, &#39;linewidth&#39;, 3)</div>
<div class="line">if nargin == 2</div>
<div class="line">hold on</div>
<div class="line">tibiaTrack = accelerationsTracking.getDependentColumn(...</div>
<div class="line">    &#39;/bodyset/tibia_r/tibia_r_imu_offset&#39;).getAsMat();</div>
<div class="line">plot(time, tibiaTrack(:,1), &#39;b--&#39;, &#39;linewidth&#39;, 3)</div>
<div class="line">end</div>
<div class="line">title(&#39;tibia&#39;)</div>
<div class="line">xlabel(&#39;time (s)&#39;)</div>
<div class="line">ylabel(&#39;acceleration (m/s^2)&#39;)</div>
<div class="line"> </div>
<div class="line">end</div>
</div><!-- fragment --> </div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:39 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
